Public Class rssfe_dvbt_example
    Dim m_Driver As rssfe

    Private Sub rssfe_dvbt_example_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Constellation.SelectedIndex = 0
        FFTMode.SelectedIndex = 0

        InputHP.SelectedIndex = 0
        CodeRateHP.SelectedIndex = 0
        TestSignalHP.SelectedIndex = 0
        SourceHP.SelectedIndex = 0

        InputLP.SelectedIndex = 0
        CodeRateLP.SelectedIndex = 0
        TestSignalLP.SelectedIndex = 0
        SourceLP.SelectedIndex = 0

    End Sub

    Private Sub ExitButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitButton.Click
        If MessageBox.Show("Are you sure you want to exit?", "Exit?", MessageBoxButtons.YesNo) = DialogResult.Yes Then
            Try
                m_Driver.ToString()
                m_Driver.Dispose()
            Catch ex As Exception

            End Try
            Close()
        End If

    End Sub

    Private Sub Apply_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Apply.Click
        Try
            System.Windows.Forms.Cursor.Current = Cursors.WaitCursor
            Try
                m_Driver.ToString()
            Catch ex As Exception
                m_Driver = New rssfe(ResourceDescriptor.Text, IDQuery.Checked, ResetDevice.Checked)
            End Try

            m_Driver.systemDisplayUpdate(True)

            m_Driver.confDVBTInputSignal(rssfeConstants.PriorityHigh, SourceHP.SelectedIndex, InputHP.SelectedIndex, StuffingHP.Checked)

            Dim hierarchical As Integer
            Dim constell As Integer

            Select Case Constellation.SelectedIndex
                Case 0, 1, 2
                    hierarchical = rssfeConstants.IqcDvbtHierNone
                    constell = Constellation.SelectedIndex
                Case 3
                Case 4
                Case 5
                    hierarchical = Constellation.SelectedIndex - 2
                    constell = rssfeConstants.IqcConst16qam
                Case Else
                    hierarchical = Constellation.SelectedIndex - 5
                    constell = rssfeConstants.IqcConst64qam

            End Select

            m_Driver.confDVBTCoding(rssfeConstants.IqcDvbtChbw6, FFTMode.SelectedIndex, rssfeConstants.IqcDvbtGuar14, hierarchical, constell)
            m_Driver.confDVBTCodeRate(rssfeConstants.PriorityHigh, CodeRateHP.SelectedIndex)
            m_Driver.confDVBTTestSignal(rssfeConstants.PriorityHigh, TestSignalHP.SelectedIndex)

            If hierarchical = rssfeConstants.IqcDvbtHierA1 Then
                m_Driver.confDVBTInputSignal(rssfeConstants.PriorityLow, SourceLP.SelectedIndex, InputLP.SelectedIndex, StuffingLP.Checked)
                m_Driver.confDVBTCodeRate(rssfeConstants.PriorityLow, CodeRateLP.SelectedIndex)
                m_Driver.confDVBTTestSignal(rssfeConstants.PriorityLow, TestSignalLP.SelectedIndex)
            End If
            m_Driver.confTxModulation(ModulationState.Checked, rssfeConstants.DmSourceDtv, rssfeConstants.DmStandardDvbt, rssfeConstants.DmSpecPolarNorm)
            m_Driver.confDVBHCoding(DVBHState.Checked, rssfeConstants.IqcDvbtSymbNat)

            m_Driver.confTxFreq(Decimal.ToDouble(RFFreq.Value))
            m_Driver.confTxLevel(Decimal.ToDouble(RFLevel.Value), RFState.Checked, 20.0, rssfeConstants.RfoutAmodeAuto, rssfeConstants.PowLevDbm)

            System.Windows.Forms.Cursor.Current = Cursors.Default
        Catch ex As Exception
            Dim message As String
            message = "Instrument Status Error: "
            message += ex.Message
            MessageBox.Show(message)
        End Try

    End Sub
End Class
